package com.huimv.eco.mq;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.huimv.eco.entity.*;
import com.huimv.eco.service.*;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.RabbitHandler;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
//               Declare:声明              队列名               队列持久化 durable:持久耐用  自动删除
@RabbitListener(queuesToDeclare = @Queue(value = "hello",durable = "true",autoDelete = "true"))
public class HelloConsumer {


    @Autowired
    private IBaseRoomService baseRoomService;

    @Autowired
    private ISysHumidityService humidityService;

    @Autowired
    private ISysTemperatureService temperatureService;

    @Autowired
    private ISysFodderService fodderService;


    @Autowired
    private ISysMonthWaterService monthWaterService;

    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private RabbitTemplate rabbitTemplate;
    String url = "http://120.27.234.126:8010/receiver/receiver/eco/save";
    /**
     * Handler:处理者
     *
     * @param
     */
    @RabbitHandler
//    @RabbitListener(queues = MQConstant.ZFB_HANDLER_QUEUE)
    public void HelloConsumer(Map<String, Object> map) {
//        System.out.println("消费者："+map);


        JsonObject item = new JsonParser().parse((String) map.get("item")).getAsJsonObject();
        Long Uid = (Long) map.get("Uid");
        String name = item.get("name").getAsString();
//        System.out.println(name);
        if (name.contains("平均温度")) {
            String[] split = name.split("-");
            BaseRoom box_id = baseRoomService.getOne(new QueryWrapper<BaseRoom>().eq("room_name", split[0]).eq("box_id", Uid));
            List<SysTemperature> one = temperatureService.list(new QueryWrapper<SysTemperature>().ge("create_time", DateUtil.offsetMinute(new Date(),-1)).eq("room_id",box_id.getId()));
            if (ObjectUtil.isEmpty(one)) {
                SysTemperature sysTemperature = new SysTemperature();
                sysTemperature.setCreateTime(new Date(item.get("t").getAsLong()));
                sysTemperature.setRoomId(box_id.getId());
                sysTemperature.setOriginal(item.get("value").getAsDouble());
                sysTemperature.setValue(new BigDecimal(item.get("value").getAsDouble() * 0.1).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue());
                sysTemperature.setFarmId(1);
                sysTemperature.setId(item.get("id").getAsString());
                temperatureService.save(sysTemperature);
//                System.out.println(item+"Uid = "+Uid);
            }

        }

        if (name.contains("湿度")) {
            String[] split = name.split("-");
            BaseRoom box_id = baseRoomService.getOne(new QueryWrapper<BaseRoom>().eq("room_name", split[0]).eq("box_id", Uid));
            List<SysHumidity> one = humidityService.list(new QueryWrapper<SysHumidity>().ge("create_time", DateUtil.offsetMinute(new Date(),-1)).eq("room_id",box_id.getId()));
            if (ObjectUtil.isEmpty(one)) {
                SysHumidity sysHumidity = new SysHumidity();
                sysHumidity.setCreateTime(new Date(item.get("t").getAsLong()));
                sysHumidity.setRoomId(box_id.getId());
                sysHumidity.setValue(new BigDecimal(item.get("value").getAsDouble()).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue());
                sysHumidity.setFarmId(1);
                sysHumidity.setId(item.get("id").getAsString());

                humidityService.save(sysHumidity);
//                System.out.println(item+"Uid = "+Uid);
            }

//
        }

        //String oneUid = "-1277226674647203111";
        //        String twoUid = "-1277176930335980834";
        //        String threeUid = "-1277075358654397725";
        if (name.contains("累计重量")) {
            System.out.println(name);
            if (-1277226674647203111L == Uid) {

                saveFodder(item, 1);

            }
            if (-1277176930335980834L == Uid) {
                saveFodder(item, 2);
            }
            if (-1277075358654397725L == Uid) {
                saveFodder(item, 3);
            }

        }
        List<SysMonthWater> dayWatersList = new ArrayList<>();
        if (name.contains("日用水量")) {

            String[] split = name.split("-");
            BaseRoom room = baseRoomService.getOne(new QueryWrapper<BaseRoom>().eq("room_name", split[0]).eq("box_id", Uid));
            Integer roomId = room.getId();
            SysMonthWater oldWater = monthWaterService.getOne(
                    new QueryWrapper<SysMonthWater>()
                            .eq("room_id", roomId)
                            .eq("farm_id", 1)
                            .orderByDesc("month_water_id")
                            .last("LIMIT 1"));

            SysMonthWater monthWater = new SysMonthWater();
            monthWater.setFarmId(1);
            Double newValue = new BigDecimal(item.get("value").getAsDouble() * 0.1).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
            Double add;
            if (newValue == null) {
                newValue = 0.0;
            }
            if (ObjectUtil.isEmpty(oldWater)) {
                if (newValue == null) {
                    add = 0.0;
                } else {
                    add = newValue;
                }

            } else {
                Double oldValue = Double.parseDouble(oldWater.getValue());
                if (newValue >= oldValue) {
                    add = newValue - oldValue;
                } else {
                    add = newValue;
                }

            }

            DecimalFormat df = new DecimalFormat("#.00");
            if (add != 0.0) {
                String format = df.format(add);
                if (format.length() == 3) {
                    monthWater.setIncreaseValue(0 + format);
                } else {
                    monthWater.setIncreaseValue(format);
                }
            } else {
                monthWater.setIncreaseValue(add + "");
            }

            monthWater.setId(item.get("id").getAsString());
            monthWater.setRoomId(roomId);
            if (newValue == null) {
                newValue = 0.0;
            }
            if (newValue != 0.0) {
                String format = df.format(newValue);
                if (format.length() == 3) {
                    monthWater.setValue(0 + format);
                } else {
                    monthWater.setValue(format);
                }
            } else {
                monthWater.setValue(newValue + "");
            }
            monthWater.setCreateTime(new Date(item.get("t").getAsLong()));
            dayWatersList.add(monthWater);
            monthWaterService.saveBatch(dayWatersList);
            HumAndTemDto humAndTemDto = new HumAndTemDto();

            humAndTemDto.setMonthWaters(dayWatersList);
            humAndTemDto.setType(0);
            restTemplate.postForObject(url, humAndTemDto, String.class);
        }

//        System.out.println(s);

    }
    private void saveFodder(JsonObject item, int floorId) {
//        System.out.println(item+""+floorId);
        Double value = item.get("value").getAsDouble();
        SysFodder oneFodder = fodderService.getOne(new QueryWrapper<SysFodder>().eq("floor_id", floorId).last("ORDER BY fodder_id DESC limit 1"));
        Double oldVale = oneFodder.getValue();

        if (oldVale < value){
            oneFodder.setValue(value);
            oneFodder.setId(item.get("id").getAsString());
            oneFodder.setUpdateTime(new Date());
            fodderService.updateById(oneFodder);
        }else if (value < oldVale){
            SysFodder fodder = new SysFodder();
            fodder.setValue(value);
            fodder.setCreateTime(new Date(item.get("t").getAsLong()));
            fodder.setFloorId(floorId);
            fodder.setId(item.get("id").getAsString());
            fodder.setFarmId(1);
            fodder.setUpdateTime(new Date());

            fodderService.save(fodder);

        }


    }


}

