package com.huimv.eco.sgd;

import com.huimv.eco.sgd.fbox.ConsoleLoggerFactory;
import com.huimv.eco.sgd.fbox.ServerCaller;
import com.huimv.eco.sgd.fbox.StaticCredentialProvider;
import com.huimv.eco.sgd.fbox.TokenManager;
import com.huimv.eco.sgd.fbox.models.BoxGroup;
import com.huimv.eco.sgd.fbox.models.BoxReg;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.Collections;

@Component
public class SendTimer  implements CommandLineRunner {

    private static final long SLEEP_TIME = 3000;

    @Override
    public void run(String... args) throws Exception {
        System.out.println("test---------------------------------");
        ConsoleLoggerFactory loggerFactory = new ConsoleLoggerFactory();

        // 指定连接服务器的凭据参数
        TokenManager tokenManager = new TokenManager(new StaticCredentialProvider(Global.clientId, Global.clientSecret, Global.username, Global.password), Global.idServerUrl, loggerFactory);

        ServerCaller commServer = new ServerCaller(tokenManager, Global.commServerApiUrl, Global.signalrClientId, loggerFactory);
        ServerCaller appServer = new ServerCaller(tokenManager, Global.appServerApiUrl, Global.signalrClientId, loggerFactory);
        ServerCaller hdataServer = new ServerCaller(tokenManager, Global.hdataServerApiUrl, Global.signalrClientId, loggerFactory);

        Global.commServer = commServer;
        Global.appServer = appServer;
        Global.hdataServer = hdataServer;

        //建立signalr实例，signalr为单例模式
        FBoxSignalRConnection fboxSignalR = new FBoxSignalRConnection(Global.commServerSignalRUrl, Global.signalrClientId, tokenManager, Global.proxy, loggerFactory);

        // 连接SignalR推送通道
        fboxSignalR.start();
//        fboxSignalR.onHubProxyCreated();
        // signalr连上后，请看src/main/java/FBoxSignalRConnection.java 接受推送数据的回调类。
        System.out.println("Box list:");
//        try {
//以下为调接口示例，可忽略，若使用，参数请根据文档填写自己的账号下的参数

        // 获取盒子列表接口示例，可忽略
        try {
//            BoxGroup[] boxGroups = Global.appServer.executeGet("api/client/box/grouped", BoxGroup[].class);
//
//            for (BoxGroup boxGroup : boxGroups) {
//                for (BoxReg boxReg : boxGroup.boxRegs) {
//                   commServer.executePost("box/" + boxReg.boxUid + "/dmon/start", Object.class);
////                    System.out.println(o);
//
//                    Thread.sleep(1000);
//
//                }
            ArrayList<Long> boxUids = new ArrayList<>();
            Collections.addAll(boxUids,-3987994512570974018L,-3988048891151908679L,-3988105265818894156L,-3988200977017601873L,-6025535388011986450L,-6025569468577480215L,-6025600385899560476L,-6025651360718913057L,-7581223551802277610L,-7581256732572122863L,-7581284816289529588L,-7581318515676675833L,-1277226674647203111L,-1277176930335980834L,-1277075358654397725L);
            for (Long boxUid : boxUids) {
                commServer.executePost("box/" + boxUid + "/dmon/start", Object.class);
                Thread.sleep(1000);

            }
//                FBoxSignalRConnection fBoxSignalRConnection = new FBoxSignalRConnection();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}
